<?php
/*
 * Judge the request is asynchronous or not.
 */

function isAjaxURL(){
	if(isset($_GET['do']) && $_GET['do']=='ajax' || isset($_POST['do']) && $_POST['do']=='ajax'){
		return true;
	}else {
		return false;
	}
}

/*
 * Get the type of action.
 */
function getActionType(){
	if(isset($_GET['action']) && $_GET['action']){
		return trim($_GET['action']);
	}else if(isset($_POST['action']) && $_POST['action']){
		return trim($_POST['action']);
	}else{
		return ;
	}
}

/*
 * Ajax Controller
 */
function ajaxController(){
	$actionType = getActionType();
	switch ($actionType){
		case 'ajaxcomment':
			commentAjaxPost();
			break;
	}
	exit;
}

/*
 * Ajax Post Comment
 */
function commentAjaxPost(){

	global $wpdb ,$user_ID;
	$result = $wpdb->query('SELECT comment_ID from wp_comments where comment_ID=1');

	$comment_post_ID = isset($_POST['comment_post_ID']) ? (int) $_POST['comment_post_ID'] : 0;
	$status = $wpdb->get_row( $wpdb->prepare("SELECT post_status, comment_status FROM $wpdb->posts WHERE ID = %d", $comment_post_ID) );
	if ( empty($status->comment_status) ) {
		//		do_action('comment_id_not_found', $comment_post_ID);
		//		exit;
		fail('Error post ID');
	} elseif ( !comments_open($comment_post_ID) ) {
		//		do_action('comment_closed', $comment_post_ID);
		//		wp_die( __('Sorry, comments are closed for this item.') );
		fail('Sorry, comments are closed for this item.');
	} elseif ( in_array($status->post_status, array('draft', 'pending') ) ) {
		//		do_action('comment_on_draft', $comment_post_ID);
		//		exit;
		fail('he post is in draft or pending');
	} elseif ( 'trash' == $status->post_status ) {
		//		do_action('comment_on_trash', $comment_post_ID);
		//		exit;
		fail('The post is in trash box');
	} else {
		do_action('pre_comment_on_post', $comment_post_ID);
	}

	$comment_author       = ( isset($_POST['author']) )  ? trim(strip_tags($_POST['author'])) : null;
	$comment_author_email = ( isset($_POST['email']) )   ? trim($_POST['email']) : null;
	$comment_author_url   = ( isset($_POST['url']) )     ? trim($_POST['url']) : null;
	$comment_content      = ( isset($_POST['comment']) ) ? trim($_POST['comment']) : null;

	// If the user is logged in
	$user = wp_get_current_user();
	if ( $user->ID ) {
		if ( empty( $user->display_name ) )
		$user->display_name=$user->user_login;
		$comment_author       = $wpdb->escape($user->display_name);
		$comment_author_email = $wpdb->escape($user->user_email);
		$comment_author_url   = $wpdb->escape($user->user_url);
		if ( current_user_can('unfiltered_html') ) {
			if ( wp_create_nonce('unfiltered-html-comment_' . $comment_post_ID) != $_POST['_wp_unfiltered_html_comment'] ) {
				kses_remove_filters(); // start with a clean slate
				kses_init_filters(); // set up the filters
			}
		}
	} else {
		if ( get_option('comment_registration') || 'private' == $status->post_status )
		//		wp_die( __('Sorry, you must be logged in to post a comment.') );
		fail('Sorry, you must be logged in to post a comment.');
	}
	$comment_type = '';

	if ( get_option('require_name_email') && !$user->ID ) {
		if ( 6 > strlen($comment_author_email) || '' == $comment_author )
		fail('Error: please fill the required fields (name, email).');
		elseif ( !is_email($comment_author_email))
		fail('Error: please enter a valid email address.');
	}

	if ( '' == $comment_content )
	//	wp_die( __('Error: please type a comment.') );
	fail('Error: please type a comment.');

	$comment_parent = isset($_POST['comment_parent']) ? absint($_POST['comment_parent']) : 0;

	$commentdata = compact('comment_post_ID', 'comment_author', 'comment_author_email', 'comment_author_url', 'comment_content', 'comment_type', 'comment_parent', 'user_ID');

	$comment_id = wp_new_comment( $commentdata );

	$comment = get_comment($comment_id);
	if ( !$user->ID ) {
		$comment_cookie_lifetime = apply_filters('comment_cookie_lifetime', 30000000);
		setcookie('comment_author_' . COOKIEHASH, $comment->comment_author, time() + $comment_cookie_lifetime, COOKIEPATH, COOKIE_DOMAIN);
		setcookie('comment_author_email_' . COOKIEHASH, $comment->comment_author_email, time() + $comment_cookie_lifetime, COOKIEPATH, COOKIE_DOMAIN);
		setcookie('comment_author_url_' . COOKIEHASH, esc_url($comment->comment_author_url), time() + $comment_cookie_lifetime, COOKIEPATH, COOKIE_DOMAIN);
	}
	$GLOBALS['comment'] = $comment;
	?>
	
	<li id="comment-<?php comment_ID() ?>" class="<?php if($user->ID) echo 'admin'?>">
		<div class="comment-head">
		<span class="comment-number"><a href="#comment-<?php comment_ID() ?> "></a></span>
		<span class="comment-author"><?php comment_author_link() ?></span>
		<span class="comment-date">on <?php comment_date() ?> at <?php comment_time() ?></span>
		<span class="comment-photo"><?php echo get_avatar( $comment, 30,'',get_comment_author()); ?></span>
	    </div>
	    <div class="comment-content">
		<?php comment_text() ?>
	    </div>
	    <div class="comment-bottom" id="replay-<?php comment_ID() ?>">
		<a href="javascript:void(0)" title="replay to <?php echo $comment->comment_author ?>"
		   onclick="Util.reply('<?php comment_ID()?>','<?php comment_author()?>','comment','replyto','cancel','reply_comment')">[reply]</a>
	    </div>
	</li>
<?php 
}

if(isAjaxURL()){
	defined('DOING_AJAX') || define('DOING_AJAX', true);
	ajaxController();
}
?>